# Notifications

Cyberdrop-DL generates a report at the end of a run with stats about all the downloads, total runtime, errors, deduplication report, etc. By default, this report is only shown in the console and at the end of the main log file.

You can set up CDL to sent you the report via discord, email, a native notification of your OS, telegram and many other services.

## Notifications via Discord

To get notifications via discord, you need to provide a discord `webhook_url` inside the `settings.yaml` of your config.

You can learn how to setup a webhook following the [official discord guide](https://support.discord.com/hc/en-us/articles/228383668-Intro-to-Webhooks).

Optionally, you can add the tag `attach_logs=` as a prefix to your webhook url. This will tell CDL to include a copy of the main log as an attachment to Discord.

## Notifications to other services (via Apprise)

Cyberdrop-DL uses [Apprise](https://github.com/caronc/apprise) to send notifications to any of the services than they support.

{% hint style="info" %}
`apprise` is an an optional dependency; It's not installed by default with CDL. To install `cyberdrop-dl` with `apprise`, especify it as an extra while installing cyberdrop:

```shell
uv tool install cyberdrop-dl-patched[apprise]
```

{% endhint %}

### How to setup Apprise

To send notifications via Apprise, you need to create an `apprise.txt` file inside `AppData/Configs/Default`. The file must contain a list of URLs and they must be in the format of one of the supported apprise services.

You can check the full list of supported services [here](https://appriseit.com/services/).

Apprise services also support the `attach_logs=` tag to send the main log as an attachment.

{% hint style="success" %}
You can build the URL interactively on their website: [https://appriseit.com/url-builder](https://appriseit.com/url-builder/)
{% endhint %}

### Troubleshooting Apprise notifications

Cyberdrop-DL will show you a message at the end of a run telling you if the apprise notifications were successfully sent or not. If you are having trouble getting notifications via Apprise, follow their [troubleshooting guide](https://github.com/caronc/apprise/wiki/Troubleshooting).

## Examples

{% tabs %}
{% tab title="Email" %}
To get notifications via email, use this URL format in your `apprise.txt` file:

```shell
mailto://user:password@domain.com
```

{% endtab %}

{% tab title="Email + Logs" %}
Add `attach_logs` to your email URL in your `apprise.txt` file:

```shell
attach_logs=mailto://user:password@domain.com
```

{% endtab %}

{% tab title="Native OS notifications" %}
Some operating systems require additional dependencies for notifications to work. Cyberdrop-DL includes the required dependencies for Windows. Follow the url on the OS name to get additional information on how to set them up.

| OS                                                                                 | Syntax                                                                                            |
| ---------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------- |
| [Linux (DBus Notifications)](https://github.com/caronc/apprise/wiki/Notify_dbus)   | <p><code>dbus\://</code><br><code>qt://</code><br><code>glib://</code><br><code>kde://</code></p> |
| [Linux (Gnome Notifications)](https://github.com/caronc/apprise/wiki/Notify_gnome) | `gnome://`                                                                                        |
| [macOS](https://github.com/caronc/apprise/wiki/Notify_macosx)                      | `macosx://`                                                                                       |
| [Windows](https://github.com/caronc/apprise/wiki/Notify_windows)                   | `windows://`                                                                                      |
| {% endtab %}                                                                       |                                                                                                   |

{% tab title="Discord + Logs" %}
Add `attach_logs` to the `webhook_url` config option:

```shell
attach_logs=https://discord.com/api/webhooks/webhook_id/webhook_token
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://script-ware.gitbook.io/cyberdrop-dl/reference/notifications.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
